import { Component, h, Prop, State } from '@stencil/core';
export class BuildForm {
  constructor() {
    this.isStepMinimized = false;
    this.idStep = 0;
  }
  currentStep(id) {
    this.idStep = id;
    if (this.idStep >= this.datos.grupos.length) {
      this.isStepMinimized = true;
    }
    else {
      this.isStepMinimized = false;
    }
  }
  nextStep(id) {
    this.idStep = id + 1;
    if (this.idStep >= this.datos.grupos.length) {
      this.isStepMinimized = true;
    }
    else {
      this.isStepMinimized = false;
    }
  }
  previousStep(id) {
    this.idStep = id - 1;
    if (this.idStep >= this.datos.grupos.length) {
      this.isStepMinimized = true;
    }
    else {
      this.isStepMinimized = false;
    }
  }
  handleChangeInputString(event, indexStep, indexField) {
    console.log('event :>> ', event.target.value);
    this.arraySubmit = this.arraySubmit || [[], []];
    this.arraySubmit[indexStep][indexField] = event.target.value;
    console.log('arrayStep :>> ', this.arraySubmit);
  }
  handleSubmit(e) {
    e.preventDefault();
  }
  render() {
    var _a, _b;
    return (h("form", { onSubmit: e => this.handleSubmit(e) }, (_b = (_a = this.datos) === null || _a === void 0 ? void 0 : _a.grupos) === null || _b === void 0 ? void 0 :
      _b.map((paso, index) => {
        var _a;
        return (h("div", { class: "steps" },
          h("div", { class: { step: true, minimized: this.idStep !== index } },
            h("div", { class: "step-header", onClick: () => this.currentStep(index) },
              h("div", { class: "header" }, paso.nombre)),
            h("div", { class: "step-content" }, (_a = paso.requisitos) === null || _a === void 0 ? void 0 :
              _a.map((fieldForm, i) => (h("div", { class: "row" },
                h("div", { class: "col-md-12" },
                  h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.descripcion),
                  fieldForm.tipo_requisito.map(type => {
                    var _a, _b;
                    return (type === null || type === void 0 ? void 0 : type.descripcion) === 'string' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("input", { type: "text", value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" }))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'number' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("input", { type: "number", value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" }))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'text' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("textarea", { value: this.valueString, rows: 5, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" }))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'boolean' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("label", { class: "switch" },
                        h("input", { type: "checkbox", value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" }),
                        h("span", { class: "slider round" })))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'percent' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("input", { type: "range", min: 1, max: 100, value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input sliderScrd", placeholder: "Escriba aqu\u00ED" }))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'range' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("input", { type: "range", min: fieldForm.rango_valores[0].toString(), max: fieldForm.rango_valores[1].toString(), value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input sliderScrd", placeholder: "Escriba aqu\u00ED" }))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'list' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("div", { class: "scrd-dropdown" },
                        h("select", { onInput: event => this.handleChangeInputString(event, index, i), required: true },
                          h("option", { value: 0, selected: true }, "Seleccione una opci\u00F3n..."), (_a = fieldForm.rango_valores) === null || _a === void 0 ? void 0 :
                          _a.map(recipient => (h("option", { value: recipient }, recipient)))),
                        h("span", { class: "focus" })))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'multiple_list' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("div", { class: "scrd-dropdown" },
                        h("select", { onInput: event => this.handleChangeInputString(event, index, i), required: true, multiple: true },
                          h("option", { value: 0, selected: true }, "Seleccione una opci\u00F3n..."), (_b = fieldForm.rango_valores) === null || _b === void 0 ? void 0 :
                          _b.map(recipient => (h("option", { value: recipient }, recipient)))),
                        h("span", { class: "focus" })))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'date' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("div", { class: "col-md-6" },
                        h("input", { type: "date", value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" })))) : (type === null || type === void 0 ? void 0 : type.descripcion) === 'range_min_max' ? (h("div", { class: "scrd-form-field" },
                      h("span", { class: "scrd-span-input" }, fieldForm === null || fieldForm === void 0 ? void 0 : fieldForm.etiquetas[i]),
                      h("input", { type: "number", value: this.valueString, onInput: event => this.handleChangeInputString(event, index, i), class: "scrd-input", placeholder: "Escriba aqu\u00ED" }))) : null;
                  }))))),
              this.idStep === 0 ? (h("div", { class: "row" },
                h("div", { class: "col-md-12 text-center" },
                  h("button", { type: "button", class: "button button1", onClick: () => this.nextStep(index) }, "Siguiente")))) : (h("div", { class: "row" },
                h("div", { class: "col-md-12 text-center" },
                  h("button", { type: "button", class: "button button2", onClick: () => this.previousStep(index) }, "Anterior"),
                  h("button", { type: "button", class: "button button1 ml-3", onClick: () => this.nextStep(index) }, "Siguiente"))))))));
      }),
      h("div", { class: "steps" },
        h("div", { class: { step: true, minimized: !this.isStepMinimized } },
          h("div", { class: "step-header", onClick: () => this.currentStep(this.datos.grupos.length) },
            h("div", { class: "header" }, "Finalizar")),
          h("div", { class: "step-content one" },
            h("button", { type: "submit", class: "button button1" }, "Enviar"))))));
  }
  static get is() { return "scrd-build-form"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["build-form.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["build-form.css"]
  }; }
  static get properties() { return {
    "datos": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "modelBuildForm",
        "resolved": "modelBuildForm",
        "references": {
          "modelBuildForm": {
            "location": "import",
            "path": "../../interface/build-form/build-form.interface"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    }
  }; }
  static get states() { return {
    "isStepMinimized": {},
    "idStep": {},
    "valueString": {},
    "arraySubmit": {}
  }; }
}
