import { Component, h, Prop, State, Event } from '@stencil/core';
import { defaultValidator, FormValueValidator, getMaxLengthValidator } from '../../validators/formValue-validator';
export class ContinuoBox {
  constructor() {
    this._validator = defaultValidator;
  }
  handleSubmit(e) {
    e.preventDefault();
    const request = {
      input: this.value,
      select: this.secondSelectValue,
    };
    this.changed.emit(request);
  }
  handleChange(event) {
    this.value = event.target ? event.target.value : null;
    this._validator.validateInput(this.value);
  }
  handleSecondSelect(event) {
    this.secondSelectValue = event.target.value;
    this._validator.validateSelect(this.secondSelectValue);
  }
  render() {
    var _a, _b, _c, _d, _e, _f;
    const request = {
      input: this.value,
      select: this.secondSelectValue,
    };
    this._validator = FormValueValidator(request);
    this._validatorMax = getMaxLengthValidator(200);
    return (h("form", { onSubmit: e => this.handleSubmit(e) },
      h("div", { class: "scrd-card" },
        h("div", { class: "scrd-card-header" },
          h("h2", { class: "scrd-card-title" }, (_a = this.datos) === null || _a === void 0 ? void 0 : _a.titulo)),
        h("div", { class: "scrd-card-body" },
          h("div", { class: "row" },
            h("div", { class: "col-md-12" },
              h("div", { class: "scrd-form-field" },
                h("span", { class: "scrd-span-input" }, (_b = this.datos) === null || _b === void 0 ? void 0 : _b.observacion),
                h("input", { type: "text", value: this.value, onInput: event => this.handleChange(event), class: "scrd-input", placeholder: (_c = this.datos) === null || _c === void 0 ? void 0 : _c.placeholder }),
                !this._validator.validateInput(this.value) ? h("span", { class: "validation-error" }, this._validator.errorMessage) : null,
                !this._validatorMax.validate(this.value) ? h("span", { class: "validation-error" }, this._validatorMax.errorMessage) : null))),
          h("div", { class: "row" },
            h("div", { class: "col-md-7 offset-md-1" },
              h("div", { class: "scrd-dropdown" },
                h("select", { onInput: event => this.handleSecondSelect(event), required: true },
                  h("option", { value: 0, selected: true }, "Seleccione una opci\u00F3n..."), (_e = (_d = this.datos) === null || _d === void 0 ? void 0 : _d.selectOptions) === null || _e === void 0 ? void 0 :
                  _e.map(recipient => (h("option", { value: recipient === null || recipient === void 0 ? void 0 : recipient.name }, recipient === null || recipient === void 0 ? void 0 : recipient.name)))),
                h("span", { class: "focus" }))),
            h("div", { class: "col-md-2 text-center" },
              h("button", { class: "button button1", type: "submit", disabled: this._validator.validateInput(this.value) && this._validator.validateSelect(this.secondSelectValue) && this._validatorMax.validate(this.value) ? false : true }, (_f = this.datos) === null || _f === void 0 ? void 0 : _f.btn)))))));
  }
  static get is() { return "scrd-continuo-box"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["continuo-box.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["continuo-box.css"]
  }; }
  static get properties() { return {
    "datos": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "modelContinuoBox",
        "resolved": "modelContinuoBox",
        "references": {
          "modelContinuoBox": {
            "location": "import",
            "path": "../../interface/continuo-box/continuo.interface"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    },
    "validator": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "validator",
      "reflect": false
    }
  }; }
  static get states() { return {
    "value": {},
    "selectValue": {},
    "secondSelectValue": {}
  }; }
  static get events() { return [{
      "method": "changed",
      "name": "changed",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "complexType": {
        "original": "any",
        "resolved": "any",
        "references": {}
      }
    }]; }
}
